var Vue = require('vue')
var bus = new Vue()

function emitEvent(payload) {
    bus.$emit('component-communicate', payload)
}

function handleEmit() {
    bus.$on('component-communicate', ({key, value}) => {
        var list = key.split('.')
        var k = list.pop()
        if (list.length === 0) {
            Vue.set(this.$data, k, value)
        } else if (list.length === 1) {
            Vue.set(this.$data[list[0]], k, value)
        } else if (list.length === 2) {
            Vue.set(this.$data[list[0]][list[1]], k, value)
        } else {
            throw new Error('vue-bus-event: the key is too deep')
        }
    })
}

module.exports = {
    emitEvent,
    handleEmit,
    bus
}
